Index: trunk/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 433)
+++ trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 499)
@@ -31,35 +31,7 @@
 
 
-   !! namelist parameters      
-   USE in_out_manager , ONLY :  &    
-      cexper   =>   cexper,  & !: experience name for vairmer format 
-      no       =>   no    ,  & !: job number
-      nrstdt   =>   nrstdt,  & !: control of the time step (0,  & 1 or 2)
-      nit000   =>   nit000,  & !: number of the first time step
-      nitend   =>   nitend,  & !: number of the last time step
-      nleapy   =>   nleapy,  & !: Leap year calendar (0/1)
-      nwrite   =>   nwrite,  & !: frequency of OUTPUT file
-      nstock   =>   nstock,  & !: frequency of restart file
-      nprint   =>   nprint,  & !: level of print (0 no print)
-      lwp      =>   lwp   ,  & !: boolean term for mpp output
-      ln_ctl   =>   ln_ctl,  & !: = ln_ctl.AND.lwp (print control on the 1st proc)
-      nictls   =>   nictls,  & !: Start i indice for the SUM control
-      nictle   =>   nictle,  & !: End   i indice for the SUM control
-      njctls   =>   njctls,  & !: Start j indice for the SUM control
-      njctle   =>   njctle,  & !: End   j indice for the SUM control
-      isplt    =>   isplt ,  & !: number of processors following i
-      jsplt    =>   jsplt ,  & !: number of processors following j
-      ijsplt   =>   ijsplt,  & !: nb of local domain = nb of processors
-      numout   =>   numout     !: logical unit for output print
-
-
    !! run controm   
-   USE in_out_manager , ONLY :  &  
-      nstop     =>   nstop    ,  &  !: e r r o r  flag (=number of reason for a
-      !                             !                   prematurely stop the run)
-      nwarn     =>   nwarn    ,  &  !: w a r n i n g  flag (=number of warning
-      !                             !                   found during the run) 
-      cform_err =>   cform_err,  &  !:
-      cform_war =>   cform_war      !:  
+
+   USE in_out_manager
       
    USE dom_oce , ONLY :           &            
@@ -76,6 +48,4 @@
    USE dom_oce , ONLY :       & 
       nperio   =>   nperio,  & !: type of lateral boundary condition       
-      nlci     =>   nlci  ,  & !: index i for the sub domain left bottom 
-      nlcj     =>   nlcj  ,  & !: index j for the sub domain left bottom 
       nimpp    =>   nimpp ,  & !: i index for mpp-subdomain left bottom
       njmpp    =>   njmpp ,  & !: j index for mpp-subdomain left bottom
@@ -128,13 +98,28 @@
    !! vertical coordinate and scale factors
    USE dom_oce , ONLY :              &   
-      gdept    =>   gdept ,  & !: reference depth of t-points (m)
-      e3t      =>   e3t   ,  & !: reference depth of t-points (m)  
-      e3w      =>   e3w   ,  & !: reference depth of w-points (m)
-      gdepw    =>   gdepw      !: reference depth of w-points (m)
+      gdept_0    =>   gdept_0 ,  & !: reference depth of t-points (m)
+      e3t_0      =>   e3t_0   ,  & !: reference depth of t-points (m)  
+      e3w_0      =>   e3w_0   ,  & !: reference depth of w-points (m)
+      gdepw_0    =>   gdepw_0      !: reference depth of w-points (m)
+
+#if ! defined key_zco
+   USE dom_oce , ONLY :                &
+      gdep3w   =>  gdep3w  ,  & !: ???
+      gdept =>  gdept,  & !: depth of t-points (m)
+      gdepw =>  gdepw,  & !: depth of t-points (m)
+      e3t   =>  e3t  ,  & !: vertical scale factors at t-
+      e3u   =>  e3u  ,  & !: vertical scale factors at u-
+      e3v   =>  e3v  ,  & !: vertical scale factors v-
+      e3w   =>  e3w  ,  & !: w-points (m)
+      e3f   =>  e3f  ,  & !: f-points (m)
+      e3uw  =>  e3uw ,  & !: uw-points (m)
+      e3vw  =>  e3vw      !: vw-points (m)
+#endif
 
    USE dom_oce ,   ONLY :            &      
-      lk_zps   =>  lk_zps ,  & !: partial steps flag
-      lk_sco   =>  lk_sco ,  & !: s-coordinate flag
-      lk_zco   =>  lk_zco      !: z-coordinate flag
+      ln_zps   =>  ln_zps ,  & !: partial steps flag
+      ln_sco   =>  ln_sco ,  & !: s-coordinate flag
+      ln_zco   =>  ln_zco ,  & !: z-coordinate flag
+      lk_zco   =>  lk_zco      !: z-coordinate flag (1D or 3D arrays)
 
    USE lib_mpp ,   ONLY :            &     
@@ -143,26 +128,9 @@
    USE dynspg_oce ,   ONLY :            &     
       lk_dynspg_rl   =>  lk_dynspg_rl      !: rigid lid flag
-
-#if defined key_partial_steps
-   !! Partial steps ('key_partial_steps')
-   !! -----------------------------------
-   USE dom_oce , ONLY :                & 
-      gdep3w   =>  gdep3w  ,  & !: ???
-      gdept_ps =>  gdept_ps,  & !: depth of t-points (m)
-      gdepw_ps =>  gdepw_ps,  & !: depth of t-points (m)
-      e3t_ps   =>  e3t_ps  ,  & !: vertical scale factors at t-
-      e3u_ps   =>  e3u_ps  ,  & !: vertical scale factors at u-
-      e3v_ps   =>  e3v_ps  ,  & !: vertical scale factors v-
-      e3w_ps   =>  e3w_ps  ,  & !: w-points (m)
-      e3f_ps   =>  e3f_ps  ,  & !: f-points (m)
-      e3uw_ps  =>  e3uw_ps ,  & !: uw-points (m)
-      e3vw_ps  =>  e3vw_ps      !: vw-points (m)
 
    USE oce , ONLY :                &
       gtu   =>  gtu  ,  & !: t- horizontal gradient at u-
       gtv   =>  gtv       !: and v-points at bottom ocean level
-#endif
-
-#if defined key_s_coord
+
    USE dom_oce , ONLY :              &   
       hbatt   =>   hbatt  ,  & !: ocean depth at the vertical of  t-point (m)
@@ -174,5 +142,4 @@
       esigt   =>   esigt  ,  & !: vertical scale factor coef. at t-levels
       esigw   =>   esigw       !: vertical scale factor coef. at w-levels
-#endif
 
    !! masks, bathymetry
@@ -184,4 +151,9 @@
       vmask    =>   vmask ,  & !: land/ocean mask at v-points 
       fmask    =>   fmask      !: land/ocean mask at f-points 
+
+#if defined key_off_degrad
+   USE dom_oce , ONLY :                 &
+      facvol   =>   facvol     !: volume factor for degradation
+#endif
 
    USE dom_oce , ONLY :         &
@@ -270,7 +242,4 @@
       avt            =>   avt          ,  & !: vert. diffusivity coef. at w-point for temp  
       avt0           =>   avt0         ,  & !: vertical eddy diffusivity for tracers (m2/s)
-#if ! defined key_off_tra
-      l_trazdf_exp   =>   l_trazdf_exp ,  & !: explicit vertical diffusion scheme flag
-#endif
       ln_zdfnpc      =>   ln_zdfnpc         !: convection: non-penetrative convection flag
 