Index: trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 531)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/1_namelist	(revision 543)
@@ -21,17 +21,7 @@
 !  nleapy     Leap year calendar (0/1)
 !  ninist     initial state output flag (0/1)
-!  nprint     level of print (0 no print)
 !  nstock     frequency of restart file
 !  nwrite     frequency of OUTPUT file
 !  nrunoff    = 0 no, 1 runoff, 2 runoff+river mouth ups adv
-!  ln_ctl     trend control print (expensive!)
-!  nictls     start i indice to make the control SUM (very usefull to compare mono-
-!  nictle     end   i indice to make the control SUM (-versus multi processor runs)
-!  njctls     start j indice to make the control SUM (very usefull to compare mono-
-!  njctle     end   j indice to make the control SUM (-versus multi processor runs)
-!  isplt      number of processors following i
-!  jsplt      number of processors following j
-!  nbench     Bench parameter (0/1): CAUTION it must be zero except for bench
-!             for which we don't care about physical meaning of the results
 !
 !  CAUTION: for usual run scripts, logical value of
@@ -40,5 +30,5 @@
 &namrun
    no         =       0
-   cexper     =  "1_ORCA2"
+   cexper     =  "Agulhas"
    ln_rstart  = .false.
    nrstdt     =       0
@@ -48,18 +38,36 @@
    nleapy     =       0
    ninist     =       0
-   nprint     =       0
    nstock     =   10950
    nwrite     =   10950
    nrunoff    =       0
-   ln_ctl     =  .false.
-   nictls     =       0
-   nictle     =       0
-   njctls     =       0
-   njctle     =       0
-   isplt      =       1
-   jsplt      =       1
-   nbench     =       0
-/
-!-----------------------------------------------------------------------
+/
+!-----------------------------------------------------------------------
+!       nam_ctl      Control prints & Benchmark
+!-----------------------------------------------------------------------
+!  ln_ctl     trends control print (expensive!)
+!  nprint     level of print (0 no print)
+!  nictls     start i indice to make the control SUM (very usefull to compare mono-
+!  nictle     end   i indice to make the control SUM (-versus multi processor runs)
+!  njctls     start j indice to make the control SUM (very usefull to compare mono-
+!  njctle     end   j indice to make the control SUM (-versus multi processor runs)
+!  nisplt     number of processors following i
+!  njsplt     number of processors following j
+!  nbench     Bench parameter (0/1): CAUTION it must be zero except for bench
+!             for which we don't care about physical meaning of the results
+!  nbit_cmp   bit comparison mode parameter (0/1): enables bit comparison between 
+!             single and multiple processor runs.
+&namctl
+   ln_ctl =  .false.
+   nprint =       0
+   nictls =       0
+   nictle =       0
+   njctls =       0
+   njctle =       0
+   isplt  =       1
+   jsplt  =       1
+   nbench =       0
+   nbit_cmp =     0
+/
+!!-----------------------------------------------------------------------
 !       nam_mpp      Massively Parallel Processing
 !-----------------------------------------------------------------------
@@ -104,4 +112,5 @@
 !  ln_traadv_muscl    MUSCL scheme                 (default F)
 !  ln_traadv_muscl2   MUSCL2 scheme                (default F)
+!  ln_traadv_ubs      UBS scheme                   (default F)
 &nam_traadv
    ln_traadv_cen2   =  .false.
@@ -109,4 +118,5 @@
    ln_traadv_muscl  =  .false.
    ln_traadv_muscl2 =  .false.
+   ln_traadv_ubs    =  .false.
 /
 !-----------------------------------------------------------------------
@@ -252,5 +262,4 @@
 !  e3zps_rat     the minimum of e3zps_min and e3zps_rat * e3t
 !                (N.B. 0<e3zps_rat<1)
-!  ngrid      = 0/1, compute/read the horizontal mesh
 !                  (coordinates, scale factors)
 !  nmsh       =1 create a mesh file (coordinates, scale factors, masks)
@@ -272,5 +281,4 @@
    e3zps_min =     5.
    e3zps_rat =     0.1
-   ngrid     =     1
    nmsh      =     0
    nacc      =     0
@@ -562,12 +570,18 @@
 !-----------------------------------------------------------------------
 !       namtrd    diagnostics on dynamics and/or tracer trends
-!                         ('key_diatrdyn' and/or 'key_diatrtra')
-!                 or mixed-layer trends ('key_diatrdmld')
-!-----------------------------------------------------------------------
-!  ntrd    time step frequency dynamics and tracers trends
-!  nctls   control surface type in mixed-layer trends (0,1 or n<jpk)
+!                         ('key_trdyn' and/or 'key_trdtra')
+!                 or mixed-layer trends ('key_trdmld')
+!-----------------------------------------------------------------------
+!  ntrd              time step frequency dynamics and tracers trends
+!  nctls             control surface type in mixed-layer trends (0,1 or n<jpk)
+!  ln_trdmld_restart restart for ML diagnostics
+!  ucf               unit conversion factor (=1 -> /seconds | =86400. -> /day)
+!  ln_trdmld_instant flag to diagnose trends of instantantaneous or mean ML T/S
 &namtrd
    ntrd  = 365
    nctls =   0
+   ln_trdmld_restart = .false.
+   ucf   =  1.
+   ln_trdmld_instant = .false.
 /
 !-----------------------------------------------------------------------