Index: trunk/UTIL/fait_AA_make
===================================================================
--- trunk/UTIL/fait_AA_make	(revision 510)
+++ trunk/UTIL/fait_AA_make	(revision 544)
@@ -253,33 +253,33 @@
 echo 'TMP = ../../../tmp'
 echo '#-Q- sxnec  # Compiler options for NEMO (IDRIS SX5-NEC) '
-echo '#-Q- sxnec  F_O = -dw -Wf\"-A idbl4\" -sx5 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- sxnec  F_O = -dw -Wf\"-A idbl4\" -sx5 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- sxnec  F_F = $(F_O)'
 echo '#-Q- sxnec  L_X = $(L_O)'
 echo '#-Q- sx6nec  # Compiler options NEMO (CEA SX6-NEC) '
-echo '#-Q- sx6nec  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -C vopt -Wf"-P nh" -Wf',-pvctl noassume loopcnt=10000 -L transform' -I $(MODDIR) -I $(MODDIR)/oce'
-echo '#-Q- sx6nec  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- sx6nec  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -C vopt -Wf"-P nh" -Wf',-pvctl noassume loopcnt=10000 -L transform' -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
+echo '#-Q- sx6nec  F_O = -size_t64 -dw -Wf\"-A dbl4\" -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- sx6nec  F_F = $(F_O)'
 echo '#-Q- sx6nec  L_X = $(L_O) -ftrace'
 echo '#-Q- sx8brodie  # Compiler options NEMO (CEA SX6-NEC) '
-echo '#-Q- sx8brodie  F_O = -dw -Wf\"-A idbl4\" -sx8 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- sx8brodie  F_O = -dw -Wf\"-A idbl4\" -sx8 -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- sx8brodie  F_F = $(F_O)'
 echo '#-Q- sx8brodie  L_X = $(L_O)'
 echo '#-Q- sxdkrz  # Compiler options for NEMO (DKRZ SX6-NEC) '
-echo '#-Q- sxdkrz  F_O = -ew -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf"-pvctl noassume loopcnt=10000" -L transform -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- sxdkrz  F_O = -ew -sx6 -ftrace -C vopt -Wf"-init stack=nan" -Wl"-f nan" -Wf"-P nh" -Wf"-pvctl noassume loopcnt=10000" -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- sxdkrz  F_F = $(F_O)'
 echo '#-Q- sxdkrz  L_X = $(L_O) -ftrace'
 echo '#-Q- eshpux  # Compiler options for NEMO (Earth Simulator)'
 echo '#-Q- eshpux  # for super perfs!'
-echo '#-Q- eshpux  # F_O = $(FTRACE) -pi nest=5 line=10000 expin=Fmpplib.F -Wf,-A idbl4 -C hopt -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- eshpux  # F_O = $(FTRACE) -pi nest=5 line=10000 expin=Fmpplib.F -Wf,-A idbl4 -C hopt -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- eshpux  # regular options!'
-echo '#-Q- eshpux  F_O = $(FTRACE) -Wf,-A idbl4 -C vopt -P stack -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -Wf,-pvctl nomsg -Wf"-O nomsg" -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- eshpux  F_O = $(FTRACE) -Wf,-A idbl4 -C vopt -P stack -Wf"-P nh" -Wf,-pvctl noassume loopcnt=10000 -L transform -Wf,-pvctl nomsg -Wf"-O nomsg" -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- eshpux  F_F = $(F_O)'
 echo '#-Q- eshpux  L_X = $(L_O)'
 echo '#-Q- linux  # Compiler options for NEMO (pgf version)'
-echo '#-Q- linux  F_O = -Mlist -O3 -byteswapio -r8  -I $(MODDIR) -I$(MODDIR)/oce'
+echo '#-Q- linux  F_O = -Mlist -O3 -byteswapio -r8  -I $(MODDIR) -I$(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- linux  F_F = $(F_O)'
 echo '#-Q- linux  L_X = -r8 -O3'
 echo '#-Q- lxiv7  # Compiler options for NEMO (ifc version)'
-echo '#-Q- lxiv7  F_O = -O3 -r8  -I $(MODDIR) -I$(MODDIR)/oce'
+echo '#-Q- lxiv7  F_O = -O3 -r8  -I $(MODDIR) -I$(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- lxiv7  L_X = -r8 -O3'
 echo '#-Q- lxiv8  # Compiler options for NEMO (ifort version)'
@@ -288,15 +288,15 @@
 echo '#-Q- lxiv8  L_X = -r8 -O3'
 echo '#-Q- g95  # Compiler options for NEMO (g95 version)'
-echo '#-Q- g95  F_O = -O3 -fno-second-underscore -r8 -funroll-all-loops -I $(MODDIR) -I $(MODDIR)/oce'
+echo '#-Q- g95  F_O = -O3 -fno-second-underscore -r8 -funroll-all-loops -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)'
 echo '#-Q- g95  F_F = $(F_O)'
 echo '#-Q- g95  L_X = -r8 -O3'
 echo '#-Q- aix    # Compiler options for NEMO (aix version)'
-echo '#-Q- aix    F_O = -O3 -qsave -qrealsize=8 -qsuffix=f=f90 -qsuffix=cpp=F90 -qextname -qsource -q64 -qlargepage -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce' 
-echo '#-Q- aix    F_F = -O3 -qsave -qrealsize=8 -qsuffix=f=f -qsuffix=cpp=F -qfixed -qextname -qsource -q64 -qlargepage -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce' 
+echo '#-Q- aix    F_O = -O3 -qsave -qrealsize=8 -qsuffix=f=f90 -qsuffix=cpp=F90 -qextname -qsource -q64 -qlargepage -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)' 
+echo '#-Q- aix    F_F = -O3 -qsave -qrealsize=8 -qsuffix=f=f -qsuffix=cpp=F -qfixed -qextname -qsource -q64 -qlargepage -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)' 
 echo '#-Q- aix   L_O = $(F_P) -q64 -O3'
 echo '#-Q- aix   L_X = $(L_O)'
 echo '#-Q- osxxlf    # Compiler options for NEMO (osxxlf version)'
-echo '#-Q- osxxlf    F_O = -O3 -qsave -qrealsize=8 -qsuffix=f=f90 -qsuffix=cpp=F90 -qsource -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce' 
-echo '#-Q- osxxlf    F_F = -O3 -qsave -qrealsize=8 -qsuffix=f=f -qsuffix=cpp=F -qfixed -qsource -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce' 
+echo '#-Q- osxxlf    F_O = -O3 -qsave -qrealsize=8 -qsuffix=f=f90 -qsuffix=cpp=F90 -qsource -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)' 
+echo '#-Q- osxxlf    F_F = -O3 -qsave -qrealsize=8 -qsuffix=f=f -qsuffix=cpp=F -qfixed -qsource -qmaxmem=-1 -I $(MODDIR) -I $(MODDIR)/oce -I $(NCDF_INC)' 
 echo '#-Q- osxxlf    L_X = -qrealsize=8 -O3'
 
@@ -469,7 +469,10 @@
                 if [ $fuse0 != "Agrif_Types" ] 
                 then
+                if [ $fuse0 != "netcdf" ] 
+                then
 		    lfuse0=$fuse0.f90
 		    [ -f $fuse0.F90 ] && lfuse0=$fuse0.F90
 		    luse0="$luse0\n$lfuse0\n\$(MODEL_LIB)($fuse0.o)"
+                fi
                 fi
                 fi
@@ -489,7 +492,10 @@
                     if [ $fuse0 != "Agrif_Types" ] 
                     then
+                    if [ $fuse0 != "netcdf" ] 
+                    then
 		        lfuse0=$fuse0.f90
 		        [ -f $fuse0.F90 ] && lfuse0=$fuse0.F90
 		        luse0="$luse0\n$lfuse0\n\$(MODEL_LIB)($fuse0.o)"
+                    fi
                     fi
                     fi
@@ -507,4 +513,6 @@
         then
         if [ $fuse1 != "Agrif_Types" ] 
+        then
+        if [ $fuse1 != "netcdf" ] 
         then
 	    lfuse1=$fuse1.f90
@@ -518,4 +526,6 @@
                 then
                 if [ $fuse2 != "Agrif_Types" ] 
+                then
+                if [ $fuse2 != "netcdf" ] 
                 then
 		    lfuse2=$fuse2.f90
@@ -531,5 +541,8 @@
                     if [ $fuse3 != "Agrif_Types" ] 
                     then
+                    if [ $fuse3 != "netcdf" ] 
+                    then
 			luse3="$luse3\n$lfuse3\n\$(MODEL_LIB)($fuse3.o)"
+                    fi		    
                     fi		    
                     fi		    
@@ -539,5 +552,7 @@
                 fi
                 fi
+                fi
 		done
+        fi
         fi
         fi
@@ -641,4 +656,5 @@
 echo '	    ln -sf ../OPA_SRC/DTA/*.[Ffh]90      . ; \'
 echo '	    ln -sf ../OPA_SRC/SBC/*.[Ffh]90      . ; \'
+echo '	    ln -sf ../OPA_SRC/IOM/*.[Ffh]90      . ; \'
 echo '  fi '
 echo '	@check=`grep LIM_SRC .config`              ; \'